# This data is part of an experiment run at the Intel lab in
# Berkeley, where data was collected for several days from a
# wireless sensor network. We ask you to find relationships
# between time, voltage and temperature.

# Linear regression (1 covariate, affine model):
# We have already written some code to plot the results to
# show you how R works. The default values for w0, w1 are
# wrong and you must implement linear regression to find
# better values. Use the model y = w0 + w1*x,
# or y = t(w) %*% x, where t() is the transpose and %*% is
# matrix multiplication.
# Report w.

A = read.table("voltage_temperature.data", header=TRUE);
print("The first 3 lines of A are:");
print(A[1:3,]);
# <REPLACE THE FOLLOWING LINE BY YOUR CODE>
w = c(-116,50);  # w0, w1
x = c(min(A$voltage), max(A$voltage));
plot(A$voltage, A$temperature, col="black");
lines(x, cbind(c(1, 1), x) %*% w, col="red");

# Multivariate linear regression (2 covariates, affine model):
# Use a model of the form y = w0 + w1*x1 + w2*x2.
# Report w.
B = read.table("seconds_voltage_temperature.data", header=TRUE);	
print("The first 3 lines of B are:");
print(B[1:3,]);
# <FILL IN HERE>

# The data above has been sanitized. This one is the full data.
# Would linear regression work, here? Do your best at describing what
# is going on. (Hint: the rows are arranged in the order they were
# emitted by the sensor, the number of seconds is a time stamp
# contained in the packet).
C = read.table("seconds_voltage_temperature_full.data", header=TRUE);
print("The first 3 lines of C are:");
print(C[1:3,]);
