#Load the e1071 (SVM) library
library('e1071')
#Load some helper functions
source('hw1-helper.R')

#Read in the data
toy<-read.table("toy.data",header=TRUE)
toy$y<-factor(toy$y)

#Split the data into training, validation and test sets.  Even though
#we do a sequential split here, that only works because the order of the
#data in the file is random.  In other contexts, make sure that the training,
#validation and test sets are all representative samples.
train <- toy[1:599,]
validation <- toy[600:799,]
test <- toy[800:999,]

#Train a basic model.  The y~. means that the SVM should model y based on
#the remaining variables.
model <- svm(y~., data=train, kernel="linear")

#Plot the decision boundry, using points from the training dataset
plot(model, train)

#Compute the accuracy of the model on the training set 
svm_accuracy(model, train)

#Get the confusion matrix on the training set 
table(predict(model, train), train$y)


#################################
# Assignment
#################################
# 3.1  Train a SVM with a linear kernel (code provided above).  Plot the
# learned function and obseve that there is a mismatch between the learned
# decision boundary and the layout of the data.  
#
# 3.2  Train models using the radial and polynomial kernels. Observe and 
#report on the effect that changing the degree of the polynomial has. Also, 
#note the large difference in the decision boundry of zero versus non-zero coef0
#when using a polynomial kernel. Why does changing the degree of the polynomial 
#not have a large effect on the shape of the classification boundry when coef0 
#> 0?
#Hint: Look at the documentation for the svm function to see what changing coef0
#does.
#Play around with different parameters and select the best one. While tuning 
# parameters, only test on the validation set to prevent overfitting; report 
# final results of the chosen parameters on the test set.  Report your findings
#
# 3.3 (Optional)
# Instead of using a fixed training and validation set for choosing parameters,
# you can apply cross validation.  Write code to select the parameters using
# cross-validation and use that to train the model.  Report the parameters.
